!=========================================================================
! Copyright (C) GemTalk Systems 1986-2015.  All Rights Reserved.
!
! $Id: AnsiExceptions.gs 38145 2015-11-30 19:55:10Z lalmarod $
!
! Define various classes for ANSI Exceptions and GemStone Errors
!
!=========================================================================

expectvalue %String
run
Object _newKernelSubclass: 'ExceptionA'
  instVarNames: #( tag messageText handler
                    action result gsCategory gsNumber
                    gsArguments)
  classVars: #( TraceLog)
  classInstVars: #()
  poolDictionaries: #[]
  inDictionary: Globals
  constraints: #[  ]
  instancesInvariant: false
  isModifiable: false
  reservedOop: nil
%

expectvalue %String
run
ExceptionA _newKernelSubclass: 'Error'
  instVarNames: #()
  classVars: #()
  classInstVars: #()
  poolDictionaries: #[]
  inDictionary: Globals
  constraints: #[  ]
  instancesInvariant: false
  isModifiable: false
  reservedOop: nil
%

expectvalue %String
run
| oldClass expectedInstVars newClass |
expectedInstVars := #(#'tryBlock' #'handlerBlock' #'gsException' 
	#'returnBlock' #'resumeBlock' #'alternateBlock'
	#'exceptionSelector' #'signaledException').
oldClass := Globals at: #ExceptionHandler otherwise: nil.
(oldClass notNil and: [oldClass instVarNames = expectedInstVars]) ifTrue: [
	^'Found expected class'.
].
newClass := Object
	subclass: 'ExceptionHandler'
	instVarNames: expectedInstVars
	classVars: #( TraceLog)
	classInstVars: #()
	poolDictionaries: #()
	inDictionary: Globals
	instancesInvariant: false
	isModifiable: false.
^(oldClass isNil 
	ifTrue: ['Created new class:'] 
	ifFalse: ['Replaced old class with:']) , '
' , newClass definition.
%



expectvalue %String
run
Object _newKernelSubclass: 'ExceptionSet'
  instVarNames: #( selectors)
  classVars: #()
  classInstVars: #()
  poolDictionaries: #[]
  inDictionary: Globals
  constraints: #[  ]
  instancesInvariant: false
  isModifiable: false
  reservedOop: nil 
%

expectvalue %String
run
Object _newKernelSubclass: 'FailedMessage'
  instVarNames: #( arguments selector)
  classVars: #()
  classInstVars: #()
  poolDictionaries: #[]
  inDictionary: Globals
  constraints: #[  ]
  instancesInvariant: false
  isModifiable: false
  reservedOop: nil
%

expectvalue %String
run
ExceptionA _newKernelSubclass: 'Notification'
  instVarNames: #()
  classVars: #()
  classInstVars: #()
  poolDictionaries: #[]
  inDictionary: Globals
  constraints: #[  ]
  instancesInvariant: false
  isModifiable: false
  reservedOop: nil
%

expectvalue %String
run
Notification _newKernelSubclass: 'Warning'
  instVarNames: #()
  classVars: #()
  classInstVars: #()
  poolDictionaries: #[]
  inDictionary: Globals
  constraints: #[  ]
  instancesInvariant: false
  isModifiable: false
  reservedOop: nil
%

expectvalue %String
run
Error _newKernelSubclass: 'MessageNotUnderstood'
  instVarNames: #( receiver)
  classVars: #()
  classInstVars: #()
  poolDictionaries: #[]
  inDictionary: Globals
  constraints: #[  ]
  instancesInvariant: false
  isModifiable: false
  reservedOop: nil
%

expectvalue %String
run
Error _newKernelSubclass: 'ZeroDivide'
  instVarNames: #()
  classVars: #()
  classInstVars: #()
  poolDictionaries: #[]
  inDictionary: Globals
  constraints: #[  ]
  instancesInvariant: false
  isModifiable: false
  reservedOop: nil
%

expectvalue %String
run
ExceptionA _newKernelSubclass: 'IgnoredException'
  instVarNames: #()
  classVars: #()
  classInstVars: #()
  poolDictionaries: #[]
  inDictionary: Globals
  constraints: #[  ]
  instancesInvariant: false
  isModifiable: false
  reservedOop: nil
%
