!=========================================================================
! Copyright (C) GemTalk Systems 1986-2015.  All Rights Reserved.
!
! $Id: ProfMonitorEntry.gs 38145 2015-11-30 19:55:10Z lalmarod $
!
! Superclass Hierarchy:
!   ProfMonitorEntry, Object.
!
!=========================================================================

expectvalue %String
run
| oldClass expectedInstVars newClass |
expectedInstVars := #(cmethod tally parents
                    children total rcvrClass recursed
                    childTallies parentTallies totalSamples elapsedTime).
oldClass := Globals at: #ProfMonitorEntry otherwise: nil.
(oldClass notNil and: [oldClass instVarNames = expectedInstVars]) ifTrue: [
	^'Found expected class'.
].
newClass := Object 
  subclass: 'ProfMonitorEntry'
  instVarNames: expectedInstVars
  classVars: #()
  classInstVars: #()
  poolDictionaries: #[]
  inDictionary: Globals
  instancesInvariant: false
  isModifiable: false.
^(oldClass isNil 
	ifTrue: ['Created new class:'] 
	ifFalse: ['Replaced old class with:']) , '
' , newClass definition.

%

! remove existing behavior from ProfMonitorEntry
removeallmethods ProfMonitorEntry
removeallclassmethods ProfMonitorEntry

! ------------------- Class methods for ProfMonitorEntry
! ------------------- Instance methods for ProfMonitorEntry
category: 'Accessing'
method: ProfMonitorEntry
children

   "Return the value of the instance variable 'children'."
   ^children
%
category: 'Updating'
method: ProfMonitorEntry
children: newValue

   "Modify the value of the instance variable 'children'."
   children := newValue
%
category: 'Accessing'
method: ProfMonitorEntry
childTallies

   "Return the value of the instance variable 'childTallies'."
   ^childTallies
%
category: 'Updating'
method: ProfMonitorEntry
childTallies: newValue

   "Modify the value of the instance variable 'childTallies'."
   childTallies := newValue
%
category: 'Accessing'
method: ProfMonitorEntry
cmethod

   "Return the value of the instance variable 'cmethod'."
   ^cmethod
%
category: 'Updating'
method: ProfMonitorEntry
cmethod: newValue

   "Modify the value of the instance variable 'cmethod'."
   cmethod := newValue
%
category: 'Accessing'
method: ProfMonitorEntry
elapsedTime

   "Return the value of the instance variable 'elapsedTime'."
   ^elapsedTime
%
category: 'Updating'
method: ProfMonitorEntry
elapsedTime: newValue

   "Modify the value of the instance variable 'elapsedTime'."
   elapsedTime := newValue
%
category: 'Accessing'
method: ProfMonitorEntry
parents

   "Return the value of the instance variable 'parents'."
   ^parents
%
category: 'Updating'
method: ProfMonitorEntry
parents: newValue

   "Modify the value of the instance variable 'parents'."
   parents := newValue
%
category: 'Accessing'
method: ProfMonitorEntry
parentTallies

   "Return the value of the instance variable 'parentTallies'."
   ^parentTallies
%
category: 'Updating'
method: ProfMonitorEntry
parentTallies: newValue

   "Modify the value of the instance variable 'parentTallies'."
   parentTallies := newValue
%
category: 'Accessing'
method: ProfMonitorEntry
rcvrClass

   "Return the value of the instance variable 'rcvrClass'."
   ^rcvrClass
%
category: 'Updating'
method: ProfMonitorEntry
rcvrClass: newValue

   "Modify the value of the instance variable 'rcvrClass'."
   rcvrClass := newValue
%
category: 'Accessing'
method: ProfMonitorEntry
recursed

   "Return the value of the instance variable 'recursed'."
   ^recursed
%
category: 'Updating'
method: ProfMonitorEntry
recursed: newValue

   "Modify the value of the instance variable 'recursed'."
   recursed := newValue
%
category: 'Accessing'
method: ProfMonitorEntry
tally

   "Return the value of the instance variable 'tally'."
   ^tally
%
category: 'Updating'
method: ProfMonitorEntry
tally: newValue

   "Modify the value of the instance variable 'tally'."
   tally := newValue
%
category: 'Accessing'
method: ProfMonitorEntry
total

   "Return the value of the instance variable 'total'."
   ^total
%
category: 'Updating'
method: ProfMonitorEntry
total: newValue

   "Modify the value of the instance variable 'total'."
   total := newValue
%
category: 'Accessing'
method: ProfMonitorEntry
totalSamples

   "Return the value of the instance variable 'totalSamples'."
   ^totalSamples
%
category: 'Updating'
method: ProfMonitorEntry
totalSamples: newValue

   "Modify the value of the instance variable 'totalSamples'."
   totalSamples := newValue
%
